#property show_inputs

extern   int   NumberOfTrials     = 4;
extern   bool  ShowInterimResults = true;

//+------------------------------------------------------------------+
int start()  {
//+------------------------------------------------------------------+

  double lot = 0.1;
  double initial_lot = lot;
  
  double Lots[1];
  
  Lots[0] = lot;  

  int EV = 0;                                             // total expectancy across all possible outcomes
  for (int i=0; i<MathPow(2,NumberOfTrials); i++)  {      // for each possible outcome.....
    string outcome = NumberToBase(i,2,NumberOfTrials);    //   create a binary string of 1s and 0s (simulating wins and losses, respectively)
    string outstr = "Outcome #" + (i+1) + "    Win(1)/loss(0) sequence = [" + outcome + "]    Betting sequence = [";

    for (int j=0; j<StringLen(outcome); j++)  {           //   for each trial (bet).....
      string trial = StringSubstr(outcome,j,1);           //     get the outcome (0=loss, 1=win)
      if (j>0)
        outstr = outstr + " ";

     outstr = outstr + StringSubstr("LW",StrToInteger(trial),1);

     if (trial == "1")  {
         int a_size = ArraySize(Lots);
         if (a_size > 2) {
             for (int jj=1; jj < a_size; jj++) {
                  Lots[jj-1] = Lots[jj];
             }
                     
             ArrayResize(Lots, a_size-2);
             if (ArraySize(Lots)>1) {
                 lot = Lots[0] + Lots[ArraySize(Lots)-1];
             }
             else if (ArraySize(Lots)==1)
                  lot = Lots[0] + initial_lot;
             else     
                  lot = initial_lot;    
         }
         else {
               ArrayResize(Lots, 0);
               lot = initial_lot;
         }   
     }
     else {
       a_size = ArraySize(Lots); 
       ArrayResize(Lots, a_size+1);     
       Lots[a_size] = lot;
       lot = Lots[0] + Lots[a_size];
     }      
    }

    outstr = outstr + "]   Ending lot = " + lot;
    EV += lot;
                                                        // sum the ending bankroll to the total expectancy value
    if (ShowInterimResults)
      MessageBox(outstr);
  }
  MessageBox("Total expectancy = sum of ending lots across all possible outcomes = " + EV);  
  return(0);
}

//+------------------------------------------------------------------+
string NumberToBase(int n, int base, int pad)
//+------------------------------------------------------------------+
// Converts a base 10 number to another base, left-padded with zeros
// Usage:   int x=BaseToNumber(220,16,4)   returns x="00DC"
{
  string cnvstr = "0123456789ABCDEF";
  string outstr = "";
  while (n>0)  {
    int x = MathMod(n,base);    
    outstr = StringSubstr(cnvstr,x,1) + outstr;
    n /= base;
  }
  x = StringLen(outstr); 
  if (x < pad)
    outstr = StringRepeat("0",pad-x) + outstr;
  return(outstr);
}

//+------------------------------------------------------------------+
string StringRepeat(string str, int n)
//+------------------------------------------------------------------+
{
  string outstr = "";
  for(int i=0; i<n; i++)  {
    outstr = outstr + str;
  }
  return(outstr);
}


